Graphics3D 800,600,32,1
SetBuffer BackBuffer() 

SetBuffer BackBuffer()
font=LoadFont("",20,1,0,0)
SetFont font

Global fpsindex#,fpstime#,fpsfold_millisecs#,fpsfps#
Global Life_user#,Ybito
Const MaxHealth=100
Const Player_T=1,Map_T=2,shot_T=3,Bot_T=4
Collisions  Player_T,Map_T,2,2
Collisions  shot_T,Map_T,2,2
Collisions  shot_T,Bot_T,2,2
Collisions  Bot_T,Map_T,2,2
Collisions  Bot_T,Player_T,2,2
Collisions  Bot_T,Bot_T,2,2

Global user=CreateSphere()
camera= CreateCamera(user) 
PositionEntity camera,0,7,0
CameraFogMode camera,1
CameraFogRange camera,1,900
CameraRange camera,0.01,1000
CameraFogColor camera,140,200,250


Gun=LoadMesh("Models\Gun\gun.3ds",camera)
ScaleEntity Gun, 0.1, 0.1, 0.1
RotateEntity Gun, -95, 110, 10
PositionEntity Gun,1,-1,1.8

PositionEntity user,0,5,0
EntityRadius user,3
EntityAlpha user,0
EntityType user,Player_T


Type shot
	Field entity
End Type


Type Bot
	Field entity
End Type


Function create_Shot(x#,y#,z#,pitch#,yaw#,roll#)
	s.shot=New shot
	s\entity=LoadSprite("Image\shot.bmp") 
	PositionEntity s\entity,x#,y#+5,z#
	RotateEntity s\entity,pitch#,yaw#,roll#
	EntityType s\entity,shot_T
	Return True
End Function

Function update_shot()
	For a.shot=Each shot
 MoveEntity a\entity,0,0,3
If EntityCollided (a\entity,Map_T) <> 0 Or  EntityCollided (a\entity,Bot_T)<>0
 FreeEntity a\entity
Delete a
EndIf 	
Next
End Function


Function create_Bot(x_B#,y_B#,z_B#)
	b.Bot=New Bot
	b\entity=CreateSphere(10)
	PositionEntity b\entity,x_B#,y_B#,z_B#
	EntityRadius b\entity,2.5
	EntityType b\entity,Bot_T
	Return True
End Function

Function update_Bot()
For r.Bot=Each Bot
MoveEntity r\entity,0,0,.2
PointEntity r\entity,user
If EntityCollided (r\entity,Map_T) <> 0

If CollisionX (r\entity,1) <> 0  TurnEntity r\entity,.2,0,2 MoveEntity r\entity,0,0,.1
If CollisionZ (r\entity,1) <> 0  TurnEntity r\entity,-.2,0,-2 MoveEntity r\entity,0,0,.1
TranslateEntity r\entity,0,-.42,0
EndIf 	
If EntityCollided (r\entity,Player_T) Then Life_user#=Life_user#-.2
If EntityCollided (r\entity,shot_T)<>0
Ybito=Ybito+1
create_Bot(Rnd(-10,10),24,Rnd(-10,10))
FreeEntity r\entity
Delete r
EndIf 
Next
End Function


Pricel=LoadImage("Image\Pricel.bmp")
Life=LoadImage("Image\Life.bmp")
Img = LoadImage("Image\Polosa.bmp")
ImgH = ImageHeight(Img)         
ImgW = ImageWidth(Img)





Gora=LoadMesh("Models\map.B3D")
PositionMesh Gora,0,-50,0
ScaleMesh Gora,.03,.03,.03
EntityType Gora,Map_T


create_Bot(-20,22,-20)
create_Bot(-20,22,-10)
create_Bot(-10,22,10)
Life_user=100
While Not KeyHit(1) 
Cls 
HidePointer

xxx=EntityX(user)
yyy=EntityY(user)
zzz=EntityZ(user)

update_Bot()
If MouseHit(1) Then create_Shot(EntityX(user),EntityY(user),EntityZ(user),EntityPitch(camera),EntityYaw(user),0)


V#=0.5
	u#=70
	TurnEntity camera,MouseYSpeed()*.095,0,0
	TurnEntity user,0,-MouseXSpeed()*.095,0
	If KeyDown(30)=1 Then MoveEntity user,-V#,0,0
	If KeyDown(32)=1 Then MoveEntity user,V#,0,0
	If KeyDown(17)=1 Then MoveEntity user,0,0,+V# 
	If KeyDown(31)=1 Then MoveEntity user,0,0,-V#
	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	If Abs(EntityPitch#(camera))>u# RotateEntity camera,u#*Sgn(EntityPitch#(camera)),0,0
	TranslateEntity user,0,-.22,0
	update_shot()
	RenderWorld 
    UpdateWorld
DrawImage Pricel,GraphicsWidth()/2-10,GraphicsHeight()/2
DrawImage Life,10,10
DrawImageRect img,78,27,0,0,Float(Life_user) / MaxHealth*ImgW,ImgH
Text 50,100,"Kills  "+Ybito,1,1
Text 10,200,"FPS:  "+show_fps()
Flip False
Wend
End

Function show_fps()
	fpsindex=fpsindex+1
	fpstime=fpstime+MilliSecs()-fpsfold_millisecs
	If fpstime=>1000
		fpsfps=fpsindex
		fpstime=0
		fpsindex=0
	EndIf
	fpsfold_millisecs=MilliSecs()
	Return fpsfps
End Function